/*
 * Copyright 2007 Google Inc.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */
package com.google.gwt.i18n.client.gen;

/**
 * Interface to represent the constants contained in resource bundle:
 * com/google/gwt/i18n/client/gen/TestBadKeys.properties.
 */
public interface TestBadKeys extends
    com.google.gwt.i18n.client.ConstantsWithLookup {

  /**
   * Translated "_".
   * 
   * @return translated "_"
   * @gwt.key -
   */
  String _();

  /**
   * Translated
   * "________________________________________________________________".
   * 
   * @return translated
   *         "________________________________________________________________"
   * @gwt.key ----------------------------------------------------------------
   */
  String ________________________________________________________________();

  /**
   * Translated "__dup".
   * 
   * @return translated "__dup"
   * @gwt.key .
   */
  String __dup();

  /**
   * Translated "__s".
   * 
   * @return translated "__s"
   * @gwt.key --s
   */
  String __s();

  /**
   * Translated "__s_dup".
   * 
   * @return translated "__s_dup"
   * @gwt.key -.s
   */
  String __s_dup();

  /**
   * Translated "__s_dup_dup".
   * 
   * @return translated "__s_dup_dup"
   * @gwt.key ..s
   */
  String __s_dup_dup();

  /**
   * Translated "_1_2_3_4".
   * 
   * @return translated "_1_2_3_4"
   * @gwt.key _1.2.3.4
   */
  String _1_2_3_4();

  /**
   * Translated "_c_____".
   * 
   * @return translated "_c_____"
   * @gwt.key -c..-.-
   */
  String _c_____();

  /**
   * Translated "_level".
   * 
   * @return translated "_level"
   * @gwt.key .level
   */
  String _level();

  /**
   * Translated "a__b".
   * 
   * @return translated "a__b"
   * @gwt.key a-.b
   */
  String a__b();

  /**
   * Translated "a_b_c".
   * 
   * @return translated "a_b_c"
   * @gwt.key a-b-c
   */
  String a_b_c();

  /**
   * Translated "AWT_end".
   * 
   * @return translated "AWT_end"
   * @gwt.key AWT.end
   */
  String AWT_end();

  /**
   * Translated "AWT_f5".
   * 
   * @return translated "AWT_f5"
   * @gwt.key AWT.f5
   */
  String AWT_f5();

  /**
   * Translated "cell_2_5".
   * 
   * @return translated "cell_2_5"
   * @gwt.key cell.2.5
   */
  String cell_2_5();

  /**
   * Translated "Cursor_MoveDrop_32x32_File".
   * 
   * @return translated "Cursor_MoveDrop_32x32_File"
   * @gwt.key Cursor.MoveDrop.32x32.File
   */
  String Cursor_MoveDrop_32x32_File();

  /**
   * Translated "entity_160".
   * 
   * @return translated "entity_160"
   * @gwt.key entity.160
   */
  String entity_160();

  /**
   * Translated "logger_org_hibernate_jdbc".
   * 
   * @return translated "logger_org_hibernate_jdbc"
   * @gwt.key logger.org.hibernate.jdbc
   */
  String logger_org_hibernate_jdbc();

  /**
   * Translated "maven_checkstyle_properties".
   * 
   * @return translated "maven_checkstyle_properties"
   * @gwt.key maven.checkstyle.properties
   */
  String maven_checkstyle_properties();

  /**
   * Translated "maven_jdiff_old_tag".
   * 
   * @return translated "maven_jdiff_old_tag"
   * @gwt.key maven.jdiff.old.tag
   */
  String maven_jdiff_old_tag();

  /**
   * Translated "permissions_755".
   * 
   * @return translated "permissions_755"
   * @gwt.key permissions.755
   */
  String permissions_755();

  /**
   * Translated "zh_spacer".
   * 
   * @return translated "zh_spacer"
   * @gwt.key zh.spacer
   */
  String zh_spacer();
}
